From 956ecea05d7fe2f1cd7b89a628877ac683072ffb Mon Sep 17 00:00:00 2001
From: Nicolas Boulenguez <nicolas@debian.org>
Date: Wed, 30 Dec 2020 22:54:44 +0100
Subject: [PATCH 12/21] Simplify definition of CROSS_ARCHS

---
 debian/rules | 65 ++++++++++++++++++----------------------------------
 1 file changed, 22 insertions(+), 43 deletions(-)

diff --git a/debian/rules b/debian/rules
index 3a9cc38..faaf2a3 100755
--- a/debian/rules
+++ b/debian/rules
@@ -133,57 +133,36 @@ with_cross = yes
 ifeq ($(DEB_SOURCE),binutils)
   with_native	= yes
   same_source	= yes
-  ifeq (,$(CROSS_ARCHS))
-    ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32))
-      CROSS_ARCHS =  s390x ppc64el arm64 armhf armel
-      CROSS_ARCHS += alpha hppa m68k
-      CROSS_ARCHS += powerpc ppc64 sh4 sparc64
-      CROSS_ARCHS += ia64 riscv64
-      CROSS_ARCHS += kfreebsd-amd64 kfreebsd-i386 hurd-i386
-      ifneq (,$(filter $(DEB_HOST_ARCH), i386 x32))
-        CROSS_ARCHS += amd64
-      endif
-      ifneq (,$(filter $(DEB_HOST_ARCH), amd64 x32))
-        CROSS_ARCHS += i386
-      endif
-      ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
-        CROSS_ARCHS += x32
-      endif
-    else ifeq ($(DEB_HOST_ARCH),arm64)
-      CROSS_ARCHS = armel armhf amd64 i386 ppc64el riscv64 s390x x32
-    else ifeq ($(DEB_HOST_ARCH),ppc64)
-      CROSS_ARCHS = ppc64el
-    else ifeq ($(DEB_HOST_ARCH),ppc64el)
-      CROSS_ARCHS = powerpc ppc64 amd64 i386 x32 arm64 armel armhf riscv64 s390x
-    else
-      CROSS_ARCHS =
-    endif
-  else
-    # c-t-b passes this one ...
-    CROSS_ARCHS := $(filter-out $(DEB_HOST_ARCH),$(CROSS_ARCHS))
+  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32))
+    # DEB_HOST_ARCH is filtered-out later anyway, do not test here.
+    CROSS_ARCHS ?= amd64 i386 x32 \
+                   s390x ppc64el arm64 armhf armel \
+                   alpha hppa m68k \
+                   powerpc ppc64 sh4 sparc64 \
+                   ia64 riscv64 \
+                   kfreebsd-amd64 kfreebsd-i386 hurd-i386
+  else ifeq ($(DEB_HOST_ARCH),arm64)
+    CROSS_ARCHS ?= armel armhf amd64 i386 ppc64el riscv64 s390x x32
+  else ifeq ($(DEB_HOST_ARCH),ppc64)
+    CROSS_ARCHS ?= ppc64el
+  else ifeq ($(DEB_HOST_ARCH),ppc64el)
+    CROSS_ARCHS ?= powerpc ppc64 amd64 i386 x32 arm64 armel armhf riscv64 s390x
   endif
 else ifeq ($(DEB_SOURCE),binutils-mipsen)
   with_native	=
   same_source	=
-  ifeq (,$(CROSS_ARCHS))
-    ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32 arm64 ppc64el))
-      CROSS_ARCHS = mips mipsel mips64el mips64 mipsn32 mipsn32el
-      CROSS_ARCHS += mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
-    else ifneq (,$(filter $(DEB_HOST_ARCH), arm64 ppc64el))
-      CROSS_ARCHS = mipsel mips64el
-    else
-      CROSS_ARCHS =
-    endif
-  else
-    # c-t-b passes this one ...
-    CROSS_ARCHS := $(filter-out $(DEB_HOST_ARCH),$(CROSS_ARCHS))
+  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386 x32 arm64 ppc64el))
+    CROSS_ARCHS ?= mips mipsel mips64el mips64 mipsn32 mipsn32el \
+                   mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
+  else ifneq (,$(filter $(DEB_HOST_ARCH), arm64 ppc64el))
+    CROSS_ARCHS ?= mipsel mips64el
   endif
 else
   # binutils-ports ...
-  ifeq (,$(CROSS_ARCHS))
-    CROSS_ARCHS ?= m68k sh4 mips64 mips64el
-  endif
+  CROSS_ARCHS ?= m68k sh4 mips64 mips64el
 endif
+# c-t-b passes this one ...
+CROSS_ARCHS := $(filter-out $(DEB_HOST_ARCH),$(CROSS_ARCHS))
 
 ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 hppa))
   with_hppa64 = yes
-- 
2.30.1

